<center><a href="dgefa4.c">Actual source code: dgefa4.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:24:32+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCMAT_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/*</font>
<a name="line4">  4: </a><font color="#B22222">       Inverts 4 by 4 matrix using partial pivoting.</font>

<a name="line6">  6: </a><font color="#B22222">       Used by the sparse factorization routines in </font>
<a name="line7">  7: </a><font color="#B22222">     src/mat/impls/baij/seq and src/mat/impls/bdiag/seq</font>

<a name="line9">  9: </a><font color="#B22222">       See also src/inline/ilu.h</font>

<a name="line11"> 11: </a><font color="#B22222">       This is a combination of the Linpack routines</font>
<a name="line12"> 12: </a><font color="#B22222">    dgefa() and dgedi() specialized for a <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> of 4.</font>

<a name="line14"> 14: </a><font color="#B22222">*/</font>
<a name="line15"> 15: </a> #include <A href="../../../../../include/petsc.h.html">petsc.h</A>

<a name="line19"> 19: </a><strong><font color="#4169E1"><a name="Kernel_A_gets_inverse_A_4"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> Kernel_A_gets_inverse_A_4(MatScalar *a)</font></strong>
<a name="line20"> 20: </a>{
<a name="line21"> 21: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>   i__2,i__3,kp1,j,k,l,ll,i,ipvt[4],kb,k3;
<a name="line22"> 22: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>   k4,j3;
<a name="line23"> 23: </a>    MatScalar  *aa,*ax,*ay,work[16],stmp;
<a name="line24"> 24: </a>    MatReal    tmp,max;

<a name="line26"> 26: </a><font color="#B22222">/*     gaussian elimination with partial pivoting */</font>

<a name="line29"> 29: </a>    <font color="#B22222">/* Parameter adjustments */</font>
<a name="line30"> 30: </a>    a       -= 5;

<a name="line32"> 32: </a>    <font color="#4169E1">for</font> (k = 1; k &lt;= 3; ++k) {
<a name="line33"> 33: </a>        kp1 = k + 1;
<a name="line34"> 34: </a>        k3  = 4*k;
<a name="line35"> 35: </a>        k4  = k3 + k;
<a name="line36"> 36: </a><font color="#B22222">/*        find l = pivot index */</font>

<a name="line38"> 38: </a>        i__2 = 5 - k;
<a name="line39"> 39: </a>        aa = &amp;a[k4];
<a name="line40"> 40: </a>        max = PetscAbsScalar(aa[0]);
<a name="line41"> 41: </a>        l = 1;
<a name="line42"> 42: </a>        <font color="#4169E1">for</font> (ll=1; ll&lt;i__2; ll++) {
<a name="line43"> 43: </a>          tmp = PetscAbsScalar(aa[ll]);
<a name="line44"> 44: </a>          <font color="#4169E1">if</font> (tmp &gt; max) { max = tmp; l = ll+1;}
<a name="line45"> 45: </a>        }
<a name="line46"> 46: </a>        l       += k - 1;
<a name="line47"> 47: </a>        ipvt[k-1] = l;

<a name="line49"> 49: </a>        <font color="#4169E1">if</font> (a[l + k3] == 0.0) {
<a name="line50"> 50: </a>          <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_MAT_LU_ZRPVT,<font color="#666666">"Zero pivot, row %D"</font>,k-1);
<a name="line51"> 51: </a>        }

<a name="line53"> 53: </a><font color="#B22222">/*           interchange if necessary */</font>

<a name="line55"> 55: </a>        <font color="#4169E1">if</font> (l != k) {
<a name="line56"> 56: </a>          stmp      = a[l + k3];
<a name="line57"> 57: </a>          a[l + k3] = a[k4];
<a name="line58"> 58: </a>          a[k4]     = stmp;
<a name="line59"> 59: </a>        }

<a name="line61"> 61: </a><font color="#B22222">/*           compute multipliers */</font>

<a name="line63"> 63: </a>        stmp = -1. / a[k4];
<a name="line64"> 64: </a>        i__2 = 4 - k;
<a name="line65"> 65: </a>        aa = &amp;a[1 + k4];
<a name="line66"> 66: </a>        <font color="#4169E1">for</font> (ll=0; ll&lt;i__2; ll++) {
<a name="line67"> 67: </a>          aa[ll] *= stmp;
<a name="line68"> 68: </a>        }

<a name="line70"> 70: </a><font color="#B22222">/*           row elimination with column indexing */</font>

<a name="line72"> 72: </a>        ax = &amp;a[k4+1];
<a name="line73"> 73: </a>        <font color="#4169E1">for</font> (j = kp1; j &lt;= 4; ++j) {
<a name="line74"> 74: </a>            j3   = 4*j;
<a name="line75"> 75: </a>            stmp = a[l + j3];
<a name="line76"> 76: </a>            <font color="#4169E1">if</font> (l != k) {
<a name="line77"> 77: </a>              a[l + j3] = a[k + j3];
<a name="line78"> 78: </a>              a[k + j3] = stmp;
<a name="line79"> 79: </a>            }

<a name="line81"> 81: </a>            i__3 = 4 - k;
<a name="line82"> 82: </a>            ay = &amp;a[1+k+j3];
<a name="line83"> 83: </a>            <font color="#4169E1">for</font> (ll=0; ll&lt;i__3; ll++) {
<a name="line84"> 84: </a>              ay[ll] += stmp*ax[ll];
<a name="line85"> 85: </a>            }
<a name="line86"> 86: </a>        }
<a name="line87"> 87: </a>    }
<a name="line88"> 88: </a>    ipvt[3] = 4;
<a name="line89"> 89: </a>    <font color="#4169E1">if</font> (a[20] == 0.0) {
<a name="line90"> 90: </a>      <A href="../../../../../docs/manualpages/Sys/SETERRQ1.html#SETERRQ1">SETERRQ1</A>(PETSC_ERR_MAT_LU_ZRPVT,<font color="#666666">"Zero pivot, row %D"</font>,3);
<a name="line91"> 91: </a>    }

<a name="line93"> 93: </a>    <font color="#B22222">/*</font>
<a name="line94"> 94: </a><font color="#B22222">         Now form the inverse </font>
<a name="line95"> 95: </a><font color="#B22222">    */</font>

<a name="line97"> 97: </a>   <font color="#B22222">/*     compute inverse(u) */</font>

<a name="line99"> 99: </a>    <font color="#4169E1">for</font> (k = 1; k &lt;= 4; ++k) {
<a name="line100">100: </a>        k3    = 4*k;
<a name="line101">101: </a>        k4    = k3 + k;
<a name="line102">102: </a>        a[k4] = 1.0 / a[k4];
<a name="line103">103: </a>        stmp  = -a[k4];
<a name="line104">104: </a>        i__2  = k - 1;
<a name="line105">105: </a>        aa    = &amp;a[k3 + 1];
<a name="line106">106: </a>        <font color="#4169E1">for</font> (ll=0; ll&lt;i__2; ll++) aa[ll] *= stmp;
<a name="line107">107: </a>        kp1 = k + 1;
<a name="line108">108: </a>        <font color="#4169E1">if</font> (4 &lt; kp1) <font color="#4169E1">continue</font>;
<a name="line109">109: </a>        ax = aa;
<a name="line110">110: </a>        <font color="#4169E1">for</font> (j = kp1; j &lt;= 4; ++j) {
<a name="line111">111: </a>            j3        = 4*j;
<a name="line112">112: </a>            stmp      = a[k + j3];
<a name="line113">113: </a>            a[k + j3] = 0.0;
<a name="line114">114: </a>            ay        = &amp;a[j3 + 1];
<a name="line115">115: </a>            <font color="#4169E1">for</font> (ll=0; ll&lt;k; ll++) {
<a name="line116">116: </a>              ay[ll] += stmp*ax[ll];
<a name="line117">117: </a>            }
<a name="line118">118: </a>        }
<a name="line119">119: </a>    }

<a name="line121">121: </a>   <font color="#B22222">/*    form inverse(u)*inverse(l) */</font>

<a name="line123">123: </a>    <font color="#4169E1">for</font> (kb = 1; kb &lt;= 3; ++kb) {
<a name="line124">124: </a>        k   = 4 - kb;
<a name="line125">125: </a>        k3  = 4*k;
<a name="line126">126: </a>        kp1 = k + 1;
<a name="line127">127: </a>        aa  = a + k3;
<a name="line128">128: </a>        <font color="#4169E1">for</font> (i = kp1; i &lt;= 4; ++i) {
<a name="line129">129: </a>            work[i-1] = aa[i];
<a name="line130">130: </a>            aa[i]   = 0.0;
<a name="line131">131: </a>        }
<a name="line132">132: </a>        <font color="#4169E1">for</font> (j = kp1; j &lt;= 4; ++j) {
<a name="line133">133: </a>            stmp  = work[j-1];
<a name="line134">134: </a>            ax    = &amp;a[4*j + 1];
<a name="line135">135: </a>            ay    = &amp;a[k3 + 1];
<a name="line136">136: </a>            ay[0] += stmp*ax[0];
<a name="line137">137: </a>            ay[1] += stmp*ax[1];
<a name="line138">138: </a>            ay[2] += stmp*ax[2];
<a name="line139">139: </a>            ay[3] += stmp*ax[3];
<a name="line140">140: </a>        }
<a name="line141">141: </a>        l = ipvt[k-1];
<a name="line142">142: </a>        <font color="#4169E1">if</font> (l != k) {
<a name="line143">143: </a>            ax = &amp;a[k3 + 1];
<a name="line144">144: </a>            ay = &amp;a[4*l + 1];
<a name="line145">145: </a>            stmp = ax[0]; ax[0] = ay[0]; ay[0] = stmp;
<a name="line146">146: </a>            stmp = ax[1]; ax[1] = ay[1]; ay[1] = stmp;
<a name="line147">147: </a>            stmp = ax[2]; ax[2] = ay[2]; ay[2] = stmp;
<a name="line148">148: </a>            stmp = ax[3]; ax[3] = ay[3]; ay[3] = stmp;
<a name="line149">149: </a>        }
<a name="line150">150: </a>    }
<a name="line151">151: </a>    <font color="#4169E1">return</font>(0);
<a name="line152">152: </a>}

<a name="line154">154: </a><font color="#A020F0">#if defined(PETSC_HAVE_SSE)</font>
<a name="line155">155: </a><font color="#A020F0">#include PETSC_HAVE_SSE</font>

<a name="line159">159: </a><strong><font color="#4169E1"><a name="Kernel_A_gets_inverse_A_4_SSE"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> Kernel_A_gets_inverse_A_4_SSE(float *a)</font></strong>
<a name="line160">160: </a>{
<a name="line161">161: </a>  <font color="#B22222">/* </font>
<a name="line162">162: </a><font color="#B22222">     This routine is converted from Intel's Small Matrix Library.</font>
<a name="line163">163: </a><font color="#B22222">     See: Streaming SIMD Extensions -- Inverse of 4x4 Matrix</font>
<a name="line164">164: </a><font color="#B22222">     Order Number: 245043-001</font>
<a name="line165">165: </a><font color="#B22222">     March 1999</font>
<a name="line166">166: </a><font color="#B22222">     http://www.intel.com</font>

<a name="line168">168: </a><font color="#B22222">     Inverse of a 4x4 matrix via Kramer's Rule:</font>
<a name="line169">169: </a><font color="#B22222">     bool Invert4x4(SMLXMatrix &amp;);</font>
<a name="line170">170: </a><font color="#B22222">  */</font>

<a name="line173">173: </a>  SSE_SCOPE_BEGIN;
<a name="line174">174: </a>    SSE_INLINE_BEGIN_1(a)

<a name="line176">176: </a><font color="#B22222">/* ----------------------------------------------- */</font>

<a name="line178">178: </a>      SSE_LOADL_PS(SSE_ARG_1,FLOAT_0,XMM0)
<a name="line179">179: </a>      SSE_LOADH_PS(SSE_ARG_1,FLOAT_4,XMM0)

<a name="line181">181: </a>      SSE_LOADL_PS(SSE_ARG_1,FLOAT_8,XMM5)
<a name="line182">182: </a>      SSE_LOADH_PS(SSE_ARG_1,FLOAT_12,XMM5)

<a name="line184">184: </a>      SSE_COPY_PS(XMM3,XMM0)
<a name="line185">185: </a>      SSE_SHUFFLE(XMM3,XMM5,0x88)

<a name="line187">187: </a>      SSE_SHUFFLE(XMM5,XMM0,0xDD)

<a name="line189">189: </a>      SSE_LOADL_PS(SSE_ARG_1,FLOAT_2,XMM0)
<a name="line190">190: </a>      SSE_LOADH_PS(SSE_ARG_1,FLOAT_6,XMM0)

<a name="line192">192: </a>      SSE_LOADL_PS(SSE_ARG_1,FLOAT_10,XMM6)
<a name="line193">193: </a>      SSE_LOADH_PS(SSE_ARG_1,FLOAT_14,XMM6)

<a name="line195">195: </a>      SSE_COPY_PS(XMM4,XMM0)
<a name="line196">196: </a>      SSE_SHUFFLE(XMM4,XMM6,0x88)

<a name="line198">198: </a>      SSE_SHUFFLE(XMM6,XMM0,0xDD)

<a name="line200">200: </a><font color="#B22222">/* ----------------------------------------------- */</font>

<a name="line202">202: </a>      SSE_COPY_PS(XMM7,XMM4)
<a name="line203">203: </a>      SSE_MULT_PS(XMM7,XMM6)

<a name="line205">205: </a>      SSE_SHUFFLE(XMM7,XMM7,0xB1)

<a name="line207">207: </a>      SSE_COPY_PS(XMM0,XMM5)
<a name="line208">208: </a>      SSE_MULT_PS(XMM0,XMM7)

<a name="line210">210: </a>      SSE_COPY_PS(XMM2,XMM3)
<a name="line211">211: </a>      SSE_MULT_PS(XMM2,XMM7)

<a name="line213">213: </a>      SSE_SHUFFLE(XMM7,XMM7,0x4E)

<a name="line215">215: </a>      SSE_COPY_PS(XMM1,XMM5)
<a name="line216">216: </a>      SSE_MULT_PS(XMM1,XMM7)
<a name="line217">217: </a>      SSE_SUB_PS(XMM1,XMM0)

<a name="line219">219: </a>      SSE_MULT_PS(XMM7,XMM3)
<a name="line220">220: </a>      SSE_SUB_PS(XMM7,XMM2)

<a name="line222">222: </a>      SSE_SHUFFLE(XMM7,XMM7,0x4E)
<a name="line223">223: </a>      SSE_STORE_PS(SSE_ARG_1,FLOAT_4,XMM7)

<a name="line225">225: </a><font color="#B22222">/* ----------------------------------------------- */</font>

<a name="line227">227: </a>      SSE_COPY_PS(XMM0,XMM5)
<a name="line228">228: </a>      SSE_MULT_PS(XMM0,XMM4)

<a name="line230">230: </a>      SSE_SHUFFLE(XMM0,XMM0,0xB1)

<a name="line232">232: </a>      SSE_COPY_PS(XMM2,XMM6)
<a name="line233">233: </a>      SSE_MULT_PS(XMM2,XMM0)
<a name="line234">234: </a>      SSE_ADD_PS(XMM2,XMM1)
<a name="line235">235: </a>
<a name="line236">236: </a>      SSE_COPY_PS(XMM7,XMM3)
<a name="line237">237: </a>      SSE_MULT_PS(XMM7,XMM0)

<a name="line239">239: </a>      SSE_SHUFFLE(XMM0,XMM0,0x4E)

<a name="line241">241: </a>      SSE_COPY_PS(XMM1,XMM6)
<a name="line242">242: </a>      SSE_MULT_PS(XMM1,XMM0)
<a name="line243">243: </a>      SSE_SUB_PS(XMM2,XMM1)

<a name="line245">245: </a>      SSE_MULT_PS(XMM0,XMM3)
<a name="line246">246: </a>      SSE_SUB_PS(XMM0,XMM7)

<a name="line248">248: </a>      SSE_SHUFFLE(XMM0,XMM0,0x4E)
<a name="line249">249: </a>      SSE_STORE_PS(SSE_ARG_1,FLOAT_12,XMM0)

<a name="line251">251: </a>      <font color="#B22222">/* ----------------------------------------------- */</font>

<a name="line253">253: </a>      SSE_COPY_PS(XMM7,XMM5)
<a name="line254">254: </a>      SSE_SHUFFLE(XMM7,XMM5,0x4E)
<a name="line255">255: </a>      SSE_MULT_PS(XMM7,XMM6)

<a name="line257">257: </a>      SSE_SHUFFLE(XMM7,XMM7,0xB1)

<a name="line259">259: </a>      SSE_SHUFFLE(XMM4,XMM4,0x4E)

<a name="line261">261: </a>      SSE_COPY_PS(XMM0,XMM4)
<a name="line262">262: </a>      SSE_MULT_PS(XMM0,XMM7)
<a name="line263">263: </a>      SSE_ADD_PS(XMM0,XMM2)

<a name="line265">265: </a>      SSE_COPY_PS(XMM2,XMM3)
<a name="line266">266: </a>      SSE_MULT_PS(XMM2,XMM7)

<a name="line268">268: </a>      SSE_SHUFFLE(XMM7,XMM7,0x4E)

<a name="line270">270: </a>      SSE_COPY_PS(XMM1,XMM4)
<a name="line271">271: </a>      SSE_MULT_PS(XMM1,XMM7)
<a name="line272">272: </a>      SSE_SUB_PS(XMM0,XMM1)
<a name="line273">273: </a>      SSE_STORE_PS(SSE_ARG_1,FLOAT_0,XMM0)

<a name="line275">275: </a>      SSE_MULT_PS(XMM7,XMM3)
<a name="line276">276: </a>      SSE_SUB_PS(XMM7,XMM2)

<a name="line278">278: </a>      SSE_SHUFFLE(XMM7,XMM7,0x4E)

<a name="line280">280: </a>      <font color="#B22222">/* ----------------------------------------------- */</font>

<a name="line282">282: </a>      SSE_COPY_PS(XMM1,XMM3)
<a name="line283">283: </a>      SSE_MULT_PS(XMM1,XMM5)

<a name="line285">285: </a>      SSE_SHUFFLE(XMM1,XMM1,0xB1)

<a name="line287">287: </a>      SSE_COPY_PS(XMM0,XMM6)
<a name="line288">288: </a>      SSE_MULT_PS(XMM0,XMM1)
<a name="line289">289: </a>      SSE_ADD_PS(XMM0,XMM7)
<a name="line290">290: </a>
<a name="line291">291: </a>      SSE_COPY_PS(XMM2,XMM4)
<a name="line292">292: </a>      SSE_MULT_PS(XMM2,XMM1)
<a name="line293">293: </a>      SSE_SUB_PS_M(XMM2,SSE_ARG_1,FLOAT_12)

<a name="line295">295: </a>      SSE_SHUFFLE(XMM1,XMM1,0x4E)

<a name="line297">297: </a>      SSE_COPY_PS(XMM7,XMM6)
<a name="line298">298: </a>      SSE_MULT_PS(XMM7,XMM1)
<a name="line299">299: </a>      SSE_SUB_PS(XMM7,XMM0)

<a name="line301">301: </a>      SSE_MULT_PS(XMM1,XMM4)
<a name="line302">302: </a>      SSE_SUB_PS(XMM2,XMM1)
<a name="line303">303: </a>      SSE_STORE_PS(SSE_ARG_1,FLOAT_12,XMM2)

<a name="line305">305: </a>      <font color="#B22222">/* ----------------------------------------------- */</font>

<a name="line307">307: </a>      SSE_COPY_PS(XMM1,XMM3)
<a name="line308">308: </a>      SSE_MULT_PS(XMM1,XMM6)

<a name="line310">310: </a>      SSE_SHUFFLE(XMM1,XMM1,0xB1)

<a name="line312">312: </a>      SSE_COPY_PS(XMM2,XMM4)
<a name="line313">313: </a>      SSE_MULT_PS(XMM2,XMM1)
<a name="line314">314: </a>      SSE_LOAD_PS(SSE_ARG_1,FLOAT_4,XMM0)
<a name="line315">315: </a>      SSE_SUB_PS(XMM0,XMM2)

<a name="line317">317: </a>      SSE_COPY_PS(XMM2,XMM5)
<a name="line318">318: </a>      SSE_MULT_PS(XMM2,XMM1)
<a name="line319">319: </a>      SSE_ADD_PS(XMM2,XMM7)

<a name="line321">321: </a>      SSE_SHUFFLE(XMM1,XMM1,0x4E)

<a name="line323">323: </a>      SSE_COPY_PS(XMM7,XMM4)
<a name="line324">324: </a>      SSE_MULT_PS(XMM7,XMM1)
<a name="line325">325: </a>      SSE_ADD_PS(XMM7,XMM0)

<a name="line327">327: </a>      SSE_MULT_PS(XMM1,XMM5)
<a name="line328">328: </a>      SSE_SUB_PS(XMM2,XMM1)

<a name="line330">330: </a>      <font color="#B22222">/* ----------------------------------------------- */</font>

<a name="line332">332: </a>      SSE_MULT_PS(XMM4,XMM3)

<a name="line334">334: </a>      SSE_SHUFFLE(XMM4,XMM4,0xB1)

<a name="line336">336: </a>      SSE_COPY_PS(XMM1,XMM6)
<a name="line337">337: </a>      SSE_MULT_PS(XMM1,XMM4)
<a name="line338">338: </a>      SSE_ADD_PS(XMM1,XMM7)

<a name="line340">340: </a>      SSE_COPY_PS(XMM0,XMM5)
<a name="line341">341: </a>      SSE_MULT_PS(XMM0,XMM4)
<a name="line342">342: </a>      SSE_LOAD_PS(SSE_ARG_1,FLOAT_12,XMM7)
<a name="line343">343: </a>      SSE_SUB_PS(XMM7,XMM0)

<a name="line345">345: </a>      SSE_SHUFFLE(XMM4,XMM4,0x4E)

<a name="line347">347: </a>      SSE_MULT_PS(XMM6,XMM4)
<a name="line348">348: </a>      SSE_SUB_PS(XMM1,XMM6)

<a name="line350">350: </a>      SSE_MULT_PS(XMM5,XMM4)
<a name="line351">351: </a>      SSE_ADD_PS(XMM5,XMM7)

<a name="line353">353: </a>      <font color="#B22222">/* ----------------------------------------------- */</font>

<a name="line355">355: </a>      SSE_LOAD_PS(SSE_ARG_1,FLOAT_0,XMM0)
<a name="line356">356: </a>      SSE_MULT_PS(XMM3,XMM0)

<a name="line358">358: </a>      SSE_COPY_PS(XMM4,XMM3)
<a name="line359">359: </a>      SSE_SHUFFLE(XMM4,XMM3,0x4E)
<a name="line360">360: </a>      SSE_ADD_PS(XMM4,XMM3)

<a name="line362">362: </a>      SSE_COPY_PS(XMM6,XMM4)
<a name="line363">363: </a>      SSE_SHUFFLE(XMM6,XMM4,0xB1)
<a name="line364">364: </a>      SSE_ADD_SS(XMM6,XMM4)

<a name="line366">366: </a>      SSE_COPY_PS(XMM3,XMM6)
<a name="line367">367: </a>      SSE_RECIP_SS(XMM3,XMM6)
<a name="line368">368: </a>      SSE_COPY_SS(XMM4,XMM3)
<a name="line369">369: </a>      SSE_ADD_SS(XMM4,XMM3)
<a name="line370">370: </a>      SSE_MULT_SS(XMM3,XMM3)
<a name="line371">371: </a>      SSE_MULT_SS(XMM6,XMM3)
<a name="line372">372: </a>      SSE_SUB_SS(XMM4,XMM6)

<a name="line374">374: </a>      SSE_SHUFFLE(XMM4,XMM4,0x00)

<a name="line376">376: </a>      SSE_MULT_PS(XMM0,XMM4)
<a name="line377">377: </a>      SSE_STOREL_PS(SSE_ARG_1,FLOAT_0,XMM0)
<a name="line378">378: </a>      SSE_STOREH_PS(SSE_ARG_1,FLOAT_2,XMM0)

<a name="line380">380: </a>      SSE_MULT_PS(XMM1,XMM4)
<a name="line381">381: </a>      SSE_STOREL_PS(SSE_ARG_1,FLOAT_4,XMM1)
<a name="line382">382: </a>      SSE_STOREH_PS(SSE_ARG_1,FLOAT_6,XMM1)

<a name="line384">384: </a>      SSE_MULT_PS(XMM2,XMM4)
<a name="line385">385: </a>      SSE_STOREL_PS(SSE_ARG_1,FLOAT_8,XMM2)
<a name="line386">386: </a>      SSE_STOREH_PS(SSE_ARG_1,FLOAT_10,XMM2)

<a name="line388">388: </a>      SSE_MULT_PS(XMM4,XMM5)
<a name="line389">389: </a>      SSE_STOREL_PS(SSE_ARG_1,FLOAT_12,XMM4)
<a name="line390">390: </a>      SSE_STOREH_PS(SSE_ARG_1,FLOAT_14,XMM4)

<a name="line392">392: </a>      <font color="#B22222">/* ----------------------------------------------- */</font>

<a name="line394">394: </a>      SSE_INLINE_END_1;
<a name="line395">395: </a>  SSE_SCOPE_END;

<a name="line397">397: </a>  <font color="#4169E1">return</font>(0);
<a name="line398">398: </a>}

<a name="line400">400: </a><font color="#A020F0">#endif</font>


</pre>
</body>

</html>
